//---------------------------------------------------------------------------

#ifndef CDFT_HIBERTH
#define CDFT_HIBERTH
//---------------------------------------------------------------------------
class TCDFT_HIBERT
{
public:

        TCDFT_HIBERT();
	virtual ~TCDFT_HIBERT();
        bool used_flag();

        bool  get_work_area(int N_span);
        bool  dft(int iflag, int real_in_flag);
        bool  abs_ln(int real_in_flag);
        bool  mk_hibert_filter();

        bool   cal_freq_resp(int nfir0, double *fir_coeff);

        bool    do_hibert( int fs, int nfir0, double *fir_coeff); // by DFT

        bool    do_hibert2( int fs, int nfir0, double *fir_coeff); // by FFT Qׂ̂ߎvZ

        double *m_real_out;    // in  order is real, real, real,.....
        double *m_comp_out;       // out order is real,imag,real,imag,....
        double *m_comp_in;       // out order is real,imag,real,imag,....
        double *h_freq;     //  order is real, real, real,.....

private:
        bool    m_used_flag;
        int     m_N;

        double *m_real_in;    // in  order is real, real, real,.....


        double *h_coeff;     //  order is real, real, real,.....



        /* below old fft */
        int f_fft( double *datas, int mode);
        int f_zyou( int zyou);
        int f_mkdat( int n);
        int f_iv_mkdat( int n); /* inv  */
        int f_bitrev( int n);
      
        double *mk;
        double *ivmk;
        int    *table;
        int    len0,nzyou0;

        bool f_set( int zyou);
        bool f_free();
        bool f_used_flag;

};


#define USE_REAL_IN 1
#define USE_COMP_IN 0
#define USE_INVERSE 1
#define USE_NON_INVERSE 0


#endif
