//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "Window_Class.h"


#include "Unit2.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
TWINDOWS_class::TWINDOWS_class()
{
     used_flag=false;
     used_flag2=false;
}
//---------------------------------------------------------------------------
TWINDOWS_class::~TWINDOWS_class()
{
     if(used_flag) free(window0);
     if(used_flag2) free(coeff0);
}
//---------------------------------------------------------------------------
bool TWINDOWS_class::make_hanning(int Length0)
{
   int i;

   window0=(double *)malloc( (Length0+4) * sizeof(double));
   used_flag=true;

   for(i=0;i<Length0;++i)
   {
   window0[i]=0.5-0.5 * cos( M_PI + i * M_PI /(double)(Length0-1) );
   }

   return true;
}
//----------------------------------------------------------------------------
bool TWINDOWS_class::make_hamming(int Length0)
{
   int i;

   window0=(double *)malloc( (Length0+4) * sizeof(double));
   used_flag=true;

   for(i=0;i<Length0;++i)
   {
   window0[i]=0.54-0.46 * cos( M_PI + i * M_PI /(double)(Length0-1) );
   }

   return true;
}
//----------------------------------------------------------------------------
int TWINDOWS_class::make_kaiser(float BAND_GENSUI_DB, float BANDWIDE_RATE)
{
   int i,norder,norder2;
   double alfa0,b0,c0;

   norder2=int((BAND_GENSUI_DB - 8.)/ ( 2.285 *  M_PI *BANDWIDE_RATE )+1);
   alfa0= 0.1102 * (BAND_GENSUI_DB - 8.7);
   norder= 2 * norder2+1;

   com_order2=norder2;
   com_order=norder;

   Form2->Memo1->Lines->Add("norder=" + IntToStr(norder) + " alfa0=" + FloatToStr(alfa0));

   window0=(double *)malloc( (norder+4) * sizeof(double));
   used_flag=true;

   b0=bessel0(alfa0);
    window0[norder2]=1.0;
   for(i=0;i<norder2;++i)
   {
    c0=(double)(norder2-i) / (double)(norder2);
    c0=1. - c0*c0;
    c0=sqrt(c0) * alfa0;
    c0=bessel0(c0);
    window0[i]= c0/b0;
    window0[norder2*2-i]=window0[i];
    // Form2->Memo1->Lines->Add(" No." + IntToStr(i+1) + " value=" + FloatToStr(window0[i]));
   }

   //for(i=0;i<norder;++i) Form2->Memo1->Lines->Add(" No." + IntToStr(i+1) + " value=" + FloatToStr(window0[i]));

   return norder;
}
//----------------------------------------------------------------------------
double TWINDOWS_class::bessel0(double x0)
{
#define NUM0 40

  int i;
  double y0,r0,u2,u20;

  y0=1.;
  r0=1.;
  u20=x0/2.0;
  u2=u20;

  y0=y0+ pow((u2 / r0),2.);

  for(i=2;i<NUM0;++i)
  {
      r0=r0 * (double)i;
      u2=u2*u20;
      y0=y0 + pow( (u2 / r0), 2.);

  }

  return y0;
}
//----------------------------------------------------------------------------
double TWINDOWS_class::sinc0(double x0)
{

          if( x0 == 0.) return 1.;
          else return (sin(x0) / x0);
}
//----------------------------------------------------------------------------
int TWINDOWS_class::make_fir_lpf_kaiser(float BAND_GENSUI_DB, float BANDWIDE_RATE,float fs2_vs_fs1)
{
    int i;
    double x0,wc0;

    make_kaiser(BAND_GENSUI_DB, BANDWIDE_RATE);

    coeff0=(double *)malloc( (com_order + 4) * sizeof(double));
    used_flag2=true;

    Form2->Memo1->Lines->Add("com_order=" + IntToStr(com_order) + " com_order2=" + IntToStr(com_order2));

    wc0= (1.- BANDWIDE_RATE) * fs2_vs_fs1;

    Form2->Memo1->Lines->Add("wc0=" + FloatToStr(wc0));


    for(i=0;i<com_order2;++i)
    {
      x0= sinc0( M_PI * (double)(com_order2 - i) * wc0);
      x0= x0 * wc0;
      x0= x0 * window0[i];
      coeff0[i]=x0;
      coeff0[com_order-1-i]=x0;
    }
    coeff0[com_order2]= wc0;

    //for(i=0;i<com_order;++i) Form2->Memo1->Lines->Add(" No." + IntToStr(i+1) + " value=" + FloatToStr(coeff0[i]));

    return com_order;
}
//---------------------------------------------------------------------------

