//------------------------------------------------------------------------------
// a study of hilbert transfer  by scilab-4.1.2
//
// to get FIR min-phase low pass filter 
// from FIR linear-phase low pass filter
// ..............................................................................
// WARNING: This program may have some bugs and you may modify this program. 
// Everything done by your own risk, if you use this program. 
//------------------------------------------------------------------------------

//(1) read point data
disp('making data...');


fs=44100.0;  // sampling frequency

gensui_A0=100;  //dB 
gensui_haba0=0.1/2;  //
fc=0.9/2;   // cut off frequency
//@
alfa0= 0.1102 * (gensui_A0 - 8.7);
KS= int( (gensui_A0 - 8) / (2.285 * 2 * %pi * gensui_haba0) + 1);
K=KS;
nsize0=2*K+1;
disp(nsize0,'nsize0=');

// fir lpf coefficient
wc=2. * %pi * fc;
a=zeros(1, nsize0);
a(K+1)= wc / %pi;
for m=K-1:-1:0
 a(m+1)= sin( (K-m) * wc) / ((K-m) * %pi);
 a(2 * K - m + 1) = a(m+1);
end
// Kaiser window
win0=window('kr',length(a),alfa0);
a= a .* win0;
// Log & plot


xIc=zeros(nsize0,1);
for i=1:nsize0
 xIc(nsize0 - i + 1)= a(i);
end
bunsi2=poly(xIc,'z','coeff');
xHi=syslin('d',bunsi2,1);


df0 = 1.0 / fs;  ////df0= 2.0 * %pi / fs;
freqdx = 0: df0: ( 1 - df0);  ////0: df0: ( 2 * %pi - df0); 
[frq0, repf0]=repfreq(xHi,freqdx);
H_list=abs( repf0);
repf0_stock=repf0;


//----------------------------------
// (5) hilbert transfer  by FFT
// H(z)=ln(|H(z)|) + j arg(H(z))
//     
lnH_list=log(H_list);    // ln(|H(input)|)

// More long n0, approximation of minimum phase will be good.
n0=length(lnH_list);

// h(n) is like hilbert filter
// h(n) is un(n) defined in Oppenheim & Schafer, Digital Signal Processing,  page 19 (j
h=zeros(lnH_list);   
h(1)=1;               // h(1)=1
if modulo(n0,2)==0 then   
 h(n0/2+1)=1;        
 h(2:n0/2)=2;
else
 h(2:(n0+1)/2)=2;
end;

IFFT0=fft(lnH_list,1);   //dft(lnH_list,1);  the inverse transform normalized by 1/n 
FFT0=fft(IFFT0 .* h,-1); // dft(IFFT0 .* h,-1);   x(k)=sum over m from 1 to n of a(m)*exp(-2i*pi*(m-1)*(k-1)/n)

// imag(FFT0) is  approximate minimum phase

ComplexH_list=zeros(H_list);
for i=1:n0
 ComplexH_list(i)= H_list(i)  * exp( %i * imag(FFT0(i))); 
end

//----------------------------------
// (6) require impluse response  by FFT
//--------------------------------------------------
IRESP0=fft(ComplexH_list,1); // complex impluse response  // dft(ComplexH_list,1);
IRESP0R=real(IRESP0);    // get real part only


//--------------------------------------------------------
// (0) misc function for display
start_freq=10.0;
end_freq=(fs/2.0) - 10.0;
step_freq=2000.0;  // many is good
scale_mode=1; // 0 linear,  1 log
function [freqa, freqd, kosuu]=get_freqs()
//
  mode0=scale_mode;
  if end_freq > (1.1 * (fs/2.0)) then
    end_freq= 0.9 * (fs/2.0);
  end
  if mode0==0 then  // linear scale
   step_freq=(end_freq-start_freq)/step_freq;
   freqa=(start_freq:step_freq:end_freq);
   freqd=((start_freq/fs):(step_freq/fs):(end_freq/fs));
  end
  if mode0==1 then  // log scale
    step0= (log(end_freq) - log(start_freq)) / step_freq;
    bairitu0= exp( step0 );
    freqa=zeros(1,2);
    freqd=zeros(1,2);
    freqa(1)=start_freq;
    freqd(1)=freqa(1)/fs;
    for v=1:int(step_freq)
      freqa(v+1)=freqa(v) * bairitu0;
      freqd(v+1)=freqa(v)/fs;
    end
  end
  s0=size(freqa);
  kosuu=s0(1,2);
endfunction
//--------------------------------------------------------
//(7) Output display
//


wb0=xget('window');  // stack old window

xset('window',0);   // create new windows
clf(); 
[db0,phi0]=dbphi(repf0_stock);
//gainplot(freqa,db0,phi0); 
bode(fs * freqdx(1,2:fs/2), db0(1,2:fs/2),phi0(1,2:fs/2));
xtitle('original frequency response of FIR linear-phase');

xset('window',1);   // create new windows
clf(); 
[db0,phi0]=dbphi(ComplexH_list);
//gainplot(freqa,db0,phi0);
bode(fs * freqdx(1,2:fs/2), db0(1,2:fs/2),phi0(1,2:fs/2));
xtitle('approximate minimum phase by hilbert transfer');


xset('window',2);   // create new windows
clf(); 
subplot(311);
plot(real(IRESP0));
xtitle('real part of impluse response');
subplot(312);
plot(20.0 * log10( abs(real(IRESP0) / real(IRESP0(1)))));
xtitle('[dB]real part of impluse response');
subplot(313);
plot(imag(IRESP0));
xtitle('imaginary part of impluse response');


//------------------------------------------
// How long need of impluse response length enough ?


SampleL=length(a);  //as same as FIR linear-phase
xIc=zeros(SampleL,1);
for i=1:SampleL
 xIc(i)= real(IRESP0(i));
end 
bunsi2=poly(xIc,'z','coeff');
xHi=syslin('d',bunsi2,1); 

xset('window',3);   // create new windows
clf();
[freqa, freqd, kosuu]=get_freqs();
[frq0, repf0]=repfreq(xHi,freqd);
[db0,phi0]=dbphi(repf0);
//gainplot(freqa,db0,phi0);
bode(freqa, db0, phi0);
xtitle('approximate minimum phase fir filter frequency response by same length as FIR linear-phase');



//----------------------------------------------
xset('window',wb0);

 SampleL=fs;  //  length is as same as fs  
xIc=zeros(SampleL,1);
for i=1:SampleL
 xIc(i)= real(IRESP0(i));
end 
bunsi2=poly(xIc,'z','coeff');
xHi=syslin('d',bunsi2,1); 
xset('window',4);   // create new windows
clf();
[freqa, freqd, kosuu]=get_freqs();
[frq0, repf0]=repfreq(xHi,freqd);
[db0,phi0]=dbphi(repf0);
//gainplot(freqa,db0,phi0);
bode(freqa, db0,phi0);
xtitle('approximate minimum phase fir filter frequency response by same length of fs');

xset('window',wb0);
//----------------------------------------------


