//============================================================================
// Sampling Rate Convertor   based  on  sampling theorem
//
//          n=+mugendai
//   x(t)= sigma x(nT) *  sin (%pai * fs* ( t - nT)) / (%pai * fs* ( t - nT))
//          n=-mugendai
//----------------------------------------------------------------------------
//                        +NSTEP0
//                x(t)  ~= sigma x(nT) * sinc(%pai * fs* ( t - nT))
//                        n=-NSTEP0
//                    ----------------------
//                When converts from high frequency to lower one, 
//                applys linear-phase fir low pass filter before above formula
//                  in order to reduce to signals under new sampling frequency.
//-----------------------------------------------------------------------------
//
//-- stack size up. uncomment if your pc have not enough memory.
/////stacksize(10000000);
//
// Get Scilab Version 
// global
   scilab_version_number=4;  // dummy set
//
   ver0=getversion();
   p0=strindex(ver0,'-');
   p1=strindex(ver0,'.');
   ver1=part(ver0,(p0(1)+1):(p1(1)-1));
   scilab_version_number=str2code(ver1)
//---------------------------------------------------------------------
// some functions to replace from scilab-4.1.2 to scilab-5.1.1
function [xmode00]=x_choose0(a,b,c)
  if scilab_version_number >= 5 then
    xmode00=x_choose(a,['Please select one and double-click it'],c);
  else
    xmode00=x_choose(a,b,c);
  end
endfunction
//---------------------------------------------------------------------
// Sound format has a difference among scilab version.
// for sound wav file
if scilab_version_number == 4 then
 f412=1;  // flag to detect scilab 4.1.2
 f511=0;
elseif scilab_version_number >= 5 then
 f412=1;
 f511=1;  // flag to detect scilab 5.1.1
else
 f412=0;
 f511=0;
end
//---------------------------------------------------------------------
// get Scilab current directory
getcwd
//--- check platform is window -----------------------------------
if isdir('c:\\') then
 f_win=1;
else
 f_win=0;
end
//
//====================================================================
// scilab's global variable
// for .wav 1
chs1=0;    // channels
qty1=0;    // data quantity,  samples
size1=0;   // actual loaded data quantity
fs1=44100;     // sampling frequency, this is dummy set
fs2=48000;      // target sampling frequency, this is dummy set
bit1=0;    // bits
wavfile1=''; //  file name,  this will be overwritten.
wdat1=zeros(1,10);// data of the .wav,  only one first channel, this will be overwritten.
wdat2=zeros(1,10);// data of the .wav,  only one first channel, this will be overwritten.
//
wdat1o=zeros(1,10);// data of the .wav,  only one first channel, this will be overwritten.
wdat2o=zeros(1,10);// data of the .wav,  only one first channel, this will be overwritten.
//
wdat1b=zeros(1,10);// data of the .wav,  only one first channel, this will be overwritten.
wdat2b=zeros(1,10);// data of the .wav,  only one first channel, this will be overwritten.
//
size1o=0;
sp1=0;
ep1=0;
//================================================================
start_read_sample=1;  // start point of read wave file
max_read_sample=1200;  // max size of actual read wave file
//================================================================
//
//for sinc
NSTEP0=200;
xziku0=[-1 * NSTEP0 :0.05: NSTEP0 ];
disp( NSTEP0, 'NSTEP0');
//
// only for sinc lpf display
wcut_per_1=0.5;  // suppose that lpf cut frequency is half of 1/2*fs
//
//===================================================================
//
// misc functions
//--------------------------------------
function [wavfile1,chs1,qty1,fs1,bit1,f412]=get_wavfile_pro()
// choose wave file

if scilab_version_number >= 5 then
    wavfile1=uigetfile(["*.wav"],"","Choose  a .wav file");
 else
    wavfile1=tk_getfile("*.wav",Title="Choose a .wav file name");
end

// read channels and samples
cs1=wavread(wavfile1,'size'); 
chs1=cs1(2);   // channel
qty1=cs1(1);   // samples
//...
if chs1 > 2 then   // invert data for scilab-4.1.2
 chs1=cs1(1);
 qty1=cs1(2);
 f412=1;
else
 f412=0;
end
//...
[y,fs1,bit1]=wavread(wavfile1,[1 1]);
endfunction
//--------------------------------------
// function display the .wav property
function disp_pro_wav()
 disp(qty1,'data quantity',bit1, 'bits',chs1,'channels',fs1,'sampling frequency');
endfunction
//--------------------------------------
function [wdat1, size1, wdat2]=read_ch_of_wav(wavfile1)
 if qty1 > max_read_sample then
  y=wavread(wavfile1, [start_read_sample max_read_sample]);
 else
  y=wavread(wavfile1);
 end
 ysize=size(y);
 if ysize(2) == chs1 then
   wdat1=zeros(1,ysize(1));
   if chs1 == 1 then
       wdat1=y';
   else
    disp('Channels are more than two, but, only 2 channel is stored.');
    wdat2=zeros(1,ysize(1));
    for v=1:ysize(1)
      wdat1(v)=y(v,1);
      wdat2(v)=y(v,2);
    end
   end
   size1=ysize(1);
   disp(size1,'stored data size is');
 elseif ysize(1) == chs1 then  // for scilab-4.1.2
 wdat1=zeros(1,ysize(2));
 if chs1 == 1 then
    wdat1=y;
   else
    disp('Channels are more than two, but, only 2 channel is stored.');
    wdat2=zeros(1,ysize(2));
    for v=1:ysize(2)
      wdat1(v)=y(1,v);
      wdat2(v)=y(2,v);
    end
   end
   size1=ysize(2);
   disp(size1,'stored data size is');
 end
endfunction
//----------------------------------------------------------------
function y0=limiter_01( x0)
// After src, some value may be overflow, then cut it into [-1 1]
 if x0 > 1. then
  y0=1.
 elseif x0 < -1. then
  y0=-1.
 else 
  y0=x0;
 end
endfunction
//----------------------------------------------------------------
function snd_save1()   //
//  this is still only one !!!!
//
wavefilename= input(' + enter file name for saved .wav file =>',["string"]);
//

if f412 == 1 then    // for windows scilab-4.1.2
 if chs1 == 2 then
   wdatw=zeros(2,size1o);
   for v=1:size1o
    wdatw(1,v)=limiter_01(wdat1o(v));
    wdatw(2,v)=limiter_01(wdat2o(v));
   end
 else
   wdatw=zeros(1,size1o);
   for v=1:size1o
    wdatw(1,v)=limiter_01(wdat1o(v));
   end
 end 
 wavwrite(wdatw ,fs2,bit1,wavefilename );
else                 // for windows scilab-3.1.1
if chs1 == 2 then
   wdatw=zeros(size1o,2);
   for v=1:size1o
    wdatw(v,1)=limiter_01(wdat1o(v));
    wdatw(v,2)=limiter_01(wdat2o(v));
   end
 else
   wdatw=zeros(size1o,1);
   for v=1:size1o
    wdatw(v,1)=limiter_01(wdat1o(v));
   end
 end 
 wavwrite(wdatw,fs2,bit1, wavefilename);
end
endfunction
//-----------------------------------------------
function plot_wave1(disp0)
 wb0=xget('window');  // stack old window
 xset('window',disp0);   // create new windows
 clf();
 if chs1 == 1 then
  plot2d(wdat1);
 else
  subplot(211);
  plot2d(wdat1);
  subplot(212);
  plot2d(wdat2);
 end
 xset('window',wb0);   // push old windows
endfunction
//-----------------------------------------------
function plot_wave1o(disp0)
 wb0=xget('window');  // stack old window
 xset('window',disp0);   // create new windows
 clf();
 if chs1 == 1 then
  plot2d(wdat1o);
 else
  subplot(211);
  plot2d(wdat1o);
  subplot(212);
  plot2d(wdat2o);
 end
 xset('window',wb0);   // push old windows
endfunction
//-------------------------------------------------------
function do_fft(indata,fsx,disp0,str0)
 s0=size(indata);
 s1=s0(2);
 n0=int(log2(s1));
 n1=2^n0;
 if n1 > 8192 then
   n1=8192;
 end
 //
 fft_point1=n1;
 win_hn=window('hn',fft_point1);  // make hanning windows data
 wdatw=zeros(1, fft_point1);
 for v=1:fft_point1
  wdatw(v)=indata(v);
 end
 wdatw2= wdatw .* win_hn;
 fftwout=fft( wdatw2, -1 );
 //
 respw=zeros(1,fft_point1/2);
 frq1=zeros(1,fft_point1/2);
 for loop=1:fft_point1/2
  respw(loop)=fftwout(loop+1) / fft_point1;
  frq1(loop)= fsx * loop/fft_point1;
 end
 [db_fft1,phi_fft1] =dbphi(respw); 
 //
 wb0=xget('window');  // stack old window
 xset('window',disp0);   // create new windows
 clf();
 gainplot(frq1,db_fft1,phi_fft1);
 wstr0='frequency response of ' + str0;
 xtitle(wstr0);
 xset('window',wb0);   // push old windows
 //
endfunction
//
//=====================================================================
//
// misc functions 2
//
//-------------------------------------------------------------------
//
start_freq=20.0;
end_freq=22000.0;
step_freq=100.0;  // many is good
scale_mode=0; // 0 linear,  1 log 
//-------------------------------------------------------------------
USE_SINC_TABLE_FLAG=0;   // SET 1 if you use sinc table.
table_size_sinc=2000;
disp( USE_SINC_TABLE_FLAG, 'USE_SINC_TABLE_FLAG=');
disp( table_size_sinc, 'table_size_sinc=');
//
function [sinc_table, sinc_delta]=make_sin_table()
if USE_SINC_TABLE_FLAG == 1 then
 sinc_table=zeros(table_size_sinc);
 sinc_delta= 2. * %pi / table_size_sinc;
 disp('making sin table...');
 for v=1:table_size_sinc
  sinc_table(v)=sin( sinc_delta * v );
 end
 disp('sinc table is ready');
else
 sinc_table=zeros(1);
 sinc_delta= 2. * %pi;
end
endfunction
//
[sinc_table, sinc_delta]=make_sin_table();
//
//-------------------------------------------------------------------
function y=sinc_tbl(x0)
 if USE_SINC_TABLE_FLAG == 1 then
    x1=abs(x0);
    if round( (x1 / sinc_delta)) == 0 then
      y=1.;
    else
      ix1= int( x1 / ( 2 * %pi));
      x2=x1 - (2 * %pi) * ix1;
      x3=x2 / sinc_delta;
      if round(x3) == 0 then
       y=0.;
      else
       y=sinc_table(round(x3)) / ( round(x3) * sinc_delta + (2 * %pi) * ix1);
      end
    end
 else
   y=sinc(x0);
 end
endfunction
//
//-------------------------------------------------------------------
function [freqa, freqd, kosuu]=get_freqs()
//
  mode0=scale_mode;
  if end_freq > (1.1 * (fs1/2.0)) then
    end_freq= 0.9 * (fs1/2.0);
  end
  if mode0==0 then  // linear scale
   step_freq=(end_freq-start_freq)/step_freq;
   freqa=(start_freq:step_freq:end_freq);
   freqd=((start_freq/fs1):(step_freq/fs1):(end_freq/fs1));
  end
  if mode0==1 then  // log scale
    step0= (log(end_freq) - log(start_freq)) / step_freq;
    bairitu0= exp( step0 );
    freqa=zeros(1,2);
    freqd=zeros(1,2);
    freqa(1)=start_freq;
    freqd(1)=freqa(1)/fs1;
    for v=1:int(step_freq)
      freqa(v+1)=freqa(v) * bairitu0;
      freqd(v+1)=freqa(v)/fs1;
    end
  end
  s0=size(freqa);
  kosuu=s0(1,2);
endfunction
//-----------------------------------------------------------------------
function y=sinc0(v)
 v1= -1 * NSTEP0 + v;
 y=wcut_per_1 * sinc( wcut_per_1 * (%pi * v1));
endfunction
//-----------------------------------------------------------------------
function sinc_res1=freq_response_sinc()
 ts=1/fs1;
 [freqa, freqd, kosuu]=get_freqs();
 sinc0f=zeros(1, NSTEP0 * 2 +1);
 for v=0:(NSTEP0 * 2)
  sinc0f(v+1)=sinc0(v);
 end
 sinc_res1=zeros(1,kosuu);
 for w=1:kosuu
  xw=2 * %pi * freqa(w) * ts;
  yi=0;
  for v=0:(NSTEP0 * 2)
   yi= yi + sinc0f(v+1) * %e^(-1. * xw * v * %i);
  end  // for v
  sinc_res1(w)=yi;  
 end  // for w
endfunction
//-----------------------------------------------------------------------
function freq_response_H0(disp0)
// 
  wb0=xget('window');  // stack old window
  xset('window',disp0);   // create new windows
  clf();
  //
  [freqa, freqd, kosuu]=get_freqs();
  //[frq,respf]=repfreq( H0, freqd );
  respf=freq_response_sinc();
  [db_fft2,phi_fft2] =dbphi(respf);
  gainplot(freqa,db_fft2,phi_fft2);
  wstr1 = 'frequency response     Hz    ';
  xtitle( wstr1,'','dB' );
 //
 xset('window',wb0);   // push old windows
endfunction
//-----------------------------------------------------
//
// linear-phase fir lpf design 
//
BANDWIDE_RATE=0.1;  //  vs fs/2(=Nyquist frequency)
BAND_GENSUI_DB=100;  // dB  >= 50
fir_order=1;
fir_coefs=ones(fir_order);
fir_delay=0;
WINDOW_TYPE=3;   // 1:hamming 2:hanning 3:kaiser window
function [coefs, norder, delay0]=fir_lpf(disp0)
  norder=int((BAND_GENSUI_DB - 8)/ ( 2.285 *  %pi *BANDWIDE_RATE )+1);
  alfa0= 0.1102 * (BAND_GENSUI_DB - 8.7);
  delay0=norder;
  norder= delay0 * 2 + 1;
  win_l=window('kr',norder,alfa0);  // kaiser window 
  disp( norder, 'order of fir lpf');
  coefs=zeros(norder);
  if fs2 < fs1 then
   wc=(1-BANDWIDE_RATE) * (fs2/2) / (fs1/2);
  else
   wc=(1-BANDWIDE_RATE) 
  end
  coefs(delay0+1)=wc;
  for v=1:delay0
    if WINDOW_TYPE == 2 then
     wx=0.5-0.5 * cos( %pi + v * %pi/delay0 );
    elseif WINDOW_TYPE == 3 then   // kaiser window
     wx=win_l(delay0+1+v);
    else
     wx=0.54-0.46 * cos( %pi + v * %pi/delay0 );  // hamming windows
    end
    coefs(delay0+1+v)= wx * wc * sinc( %pi * wc * v); 
    coefs(delay0+1-v)=coefs(delay0+1+v);
  end
  
 // freq resp
 ts=1/fs1;
 [freqa, freqd, kosuu]=get_freqs();
 fir_res1=zeros(1,kosuu);
 for w=1:kosuu
  xw=2 * %pi * freqa(w) * ts;
  yi=0;
  for v=1:norder
   yi= yi +  coefs(v) * %e^(-1. * xw * (v-1) * %i);
  end  // for v
  fir_res1(w)=yi;  
 end  // for w

 //disp freq resp
  wb0=xget('window');  // stack old window
  xset('window',disp0);   // create new windows
  clf();
  [db_fft2,phi_fft2] =dbphi(fir_res1);
  gainplot(freqa,db_fft2,phi_fft2);
  wstr1 = 'frequency response     Hz    ';
  xtitle( wstr1,'','dB' );
 //
  xset('window',wb0);   // push old windows

endfunction
//-----------------------------------------------------------------
function [wdat1b,wdat2b]=do_fir_lpf()
  wdat1b=zeros(1,size1);
  if chs1 == 2 then
   wdat2b=zeros(1,size1);
  else
   wdat2b=zeros(1,1);
  end
  
  for v=1:size1
    y1=0.;
    y2=0.;
    for v2=1:fir_order
      if (v - v2 + 1) > 0 then
        y1=y1+ fir_coefs(v2) * wdat1(v - v2 +1);
        if chs1 == 2 then
        y2=y2+ fir_coefs(v2) * wdat2(v - v2 +1);
        end
      end
    end
    // delay shift  because of linear-phase
    if (v - fir_delay +1) > 0 then
      wdat1b(v- fir_delay +1)=y1;
      if chs1 == 2 then
      wdat2b(v- fir_delay +1)=y2;
      end
    end
  end

endfunction
//
//
//
//=====================================================================
function plot_sinc1(disp0)
 wb0=xget('window');  // stack old window
 xset('window',disp0);   // create new windows
 clf();
 plot2d(xziku0,sinc(%pi * xziku0),style=[color("blue")]);
 xtitle('sinc: x- axis step is n*pai');
 xset('window',wb0);   // push old windows
endfunction
//----------------------------------------------------------------------
function [wdat1o,size1o,wdat2o]=src()
  size1o= int( size1 * ( fs2 / fs1)); 
  wdat1o=zeros(1,size1o);
  if chs1 == 2 then
   wdat2o=zeros(1,size1o);
  else
   wdat2o=zeros(1,1);
  end
  disp( size1o, fs2, fs1,'fs1:fs2:size1o');

  if fs2 < fs1 then
   b0=1;  
   ////b0=(fs2/fs1) * 0.95;
  else
   b0=1;
  end
  //----------
  for v1=1:size1o
   x1=0.0;
   x2=0.0;

   c_step= (fs1 * (v1 - 1)) / fs2  +1;
   // check c_step is integer ???
   if (int(c_step) - c_step) == 0 then
    //center
     x1=x1+ wdat1(c_step);
     if chs1 == 2 then
        x2=x2+ wdat2(c_step);
     end        
     m_step_left=c_step -1;
     m_step_right=c_step+1;
   else
     m_step_left= int(c_step);
     m_step_right= m_step_left+1;
   end
   //left part
   for v2=(-1 * NSTEP0 + 1) : 0
    if (m_step_left+v2) >= 1  then
      if USE_SINC_TABLE_FLAG == 1 then
        w0= b0 * sinc_tbl( b0 * (%pi * ( c_step  - (m_step_left + v2))));
      else
        w0= b0 * sinc( b0 * (%pi * ( c_step  - (m_step_left + v2))));
      end
      x1=x1+ wdat1(m_step_left+v2) * w0;
      if chs1 == 2 then
        x2=x2+ wdat2(m_step_left+v2) * w0;
      end 
    end
   end  // v2
   //right part
    for v2=0:(NSTEP0-1)
    if (m_step_right+v2) <= size1  then
      if USE_SINC_TABLE_FLAG == 1 then
        w0= b0 * sinc_tbl( b0 * (%pi * ( c_step  - (m_step_right + v2))));
      else
        w0= b0 * sinc( b0 * (%pi * ( c_step  - (m_step_right + v2))));
      end
      x1=x1+ wdat1(m_step_right+v2) * w0;
      if chs1 == 2 then
        x2=x2+ wdat2(m_step_right+v2) * w0;
      end 
    end
   end  // v2
   wdat1o(v1)=x1;
   if chs1 == 2 then
    wdat2o(v1)=x2;
   end

  end  // v1
  //

endfunction
//----------------------------------------------------------------------
function fs2=sel_fs2()
 SEL_CODE=x_choose0(['48000';'44100'; '32000'; '22050';'16000';'8000';'manual'],['Please select one'],'default')
 if SEL_CODE == 1 then  
    fs2=48000;
 elseif SEL_CODE == 2 then
    fs2=44100;
 elseif SEL_CODE == 3 then
    fs2=32000;
 elseif SEL_CODE == 4 then
    fs2=22050;
 elseif SEL_CODE == 5 then
    fs2=16000;
 elseif SEL_CODE == 7 then
    fs2= input(' please input new sampling frequency (fs2) =>');
 else
    fs2=8000;
 end
 disp( fs2, 'fs2=');
endfunction

//
function nstepx=set_nstep0()
   nstepx= input(' please input new NSTEP0 =>');
endfunction
//
function sin_table_size=set_table_size0()
   sin_table_size= input(' please input new sin_table_size =>');
endfunction
//
//
//=======$======&==========================#=====================
//
//  Add menu buttons of 
//
ADD_MENU_PLOT=1;       // set ADD_MENU 1 to add menu button of some functions
//
//
if ADD_MENU_PLOT == 1 then
delmenu('step1_plot_sinc');
addmenu('step1_plot_sinc',[ '(0)plot_sinc1(0)']);
step1_plot_sinc=[ 'plot_sinc1(0)' ] ;
end //if ADD_MENU_PLOT == 1 then
//
//-----------------------------------------------------------------
ADD_MENU_PLOT2=1;       // set ADD_MENU 1 to add menu button of some functions
//
//
if ADD_MENU_PLOT2 == 1 then
delmenu('step1_plotwav');
addmenu('step1_plotwav',[ '(0)read_wav(2)' ; ]);
step1_plotwav=[ '[wavfile1,chs1,qty1,fs1,bit1,f412]=get_wavfile_pro(); disp_pro_wav(); [wdat1, size1, wdat2]=read_ch_of_wav(wavfile1); sp1=1; ep1=size1; plot_wave1(2)'  ] ;
end //if ADD_MENU_PLOT2 == 1 then
//
//-----------------------------------------------------------------
//
ADD_MENU_PLOT3=1;       // set ADD_MENU 1 to add menu button of some functions
//
//
if ADD_MENU_PLOT3 == 1 then
delmenu('step1_fs2');
addmenu('step1_fs2',[ '(0)set_target_fs2' ; '(1)design_fir_lpf(3)'; '(2)do_fir_lpf(pre_filtering)'  ;'(2)src(4)'; '(E)snd_save1()' ; 'set NSTEP0']);
step1_fs2=[ 'fs2=sel_fs2();' ;'[fir_coefs, fir_order,fir_delay]=fir_lpf(3);' ; 'disp(''calling do_fir_lpf...'');[wdat1b,wdat2b]=do_fir_lpf(); wdat1=wdat1b; wdat2=wdat2b; size1=size1-(fir_delay-1); disp(''attension. wdat1 and wdat2 was applied as fir lpf'');'  ; '[wdat1o,size1o,wdat2o]=src(); plot_wave1o(4)' ;'snd_save1();' ; 'NSTEP0=set_nstep0();'] ;
end //if ADD_MENU_PLOT3 == 1 then
//
//-----------------------------------------------------------------
//
ADD_MENU_PLOT4=1;       // set ADD_MENU 1 to add menu button of some functions
//
//
if ADD_MENU_PLOT4 == 1 then
delmenu('frequency_plot');
addmenu('frequency_plot',[ '(0)fft(wdat1)(5)' ;  '(1)fft(wdat1b)(6)' ; '(0)fft(wdat1o)(7)']);
frequency_plot=[ 'do_fft(wdat1,fs1,5,''wdat1''); ' ; 'do_fft(wdat1b,fs1,6,''wdat1b''); ' ; 'do_fft(wdat1o,fs2,7,''wdat1o''); '   ] ;
end //if ADD_MENU_PLOT4 == 1 then
//
//-----------------------------------------------------------------
//